***
* Langage : Clipper 5.0 VF
* Auteur  : Algorithme en C     : Philippe Bonnardel - 1994 -
* Objet   : Affiche les rpertoires d'un drive sous forme d'une arborescence
*         : La fonction en C acclre l'algorithme
* Compil  : /M/N/W/L
* Version : 1.0                   * * * FREEWARE * * *
* Address :                        Philippe BONNARDEL
*         :                        27, Bd de VERDUN
*         :                        92400 COURBEVOIE - FRANCE 
*         :
*         : If you enjoy having and using this program, please let me now, 
*         : I'll be good to know so !
*
* Lien    : DTREE.C
***

#include "box.ch"

FUNCTION MAIN (cDrive)
LOCAL nTemp := 0, nDebut, nLaps
LOCAL aPath := {}, aRepert := {}

CLS
IF (cDrive == NIL)
    ?
    ? "* Paramter of DIRTREE.EXE :"
    ? "    - Drive"
    ?
    ? "* Examples :" 
    ? "    - dirtree C:\"
    ? "    - dirtree D:\CLIPPER5\"
    ?
    RETURN (NIL)
ENDIF

// Mise en place de l'interface
SETCURSOR (0)
SETCOLOR ("W/B")
@ 0, 0, MAXROW(), MAXCOL() + 1 BOX REPLICATE("", 9)
SETCOLOR("W+/B")
@ 0, 0 SAY PADC("DIRTREE - Philippe Bonnardel 1994 -", MAXCOL()+1)

// Fentre pour patienter pendant la lecture...
SETCOLOR ("N/G")
@ 9, 22, 11, 54 BOX B_SINGLE + CHR (32)
@ 10, 24 SAY "Lecture des rpertoires : "

// Appel de l'algo. 
SETCOLOR ("W+/G")

nDebut := SECONDS()
DIRTREE (cDrive, cDrive, aRepert, aPath, "", "", ;
         {|| devpos(10, 50), devout(str(ntemp++, 4))})
nLaps := SECONDS() - nDebut

SETCOLOR ("G+/B")
@ MAXROW(), 0 SAY PADC("  - Dure : " + LTRIM(STR(nLaps)) + " secondes -  " +;
                       LTRIM(STR(LEN(aPath)-1)) + " Rpertoire" + ;
                       IIF(LEN(aPath) > 2, "s", ""), MAXCOL()+1)

// Affiche l'arbre
SETCOLOR ("W+/BG")
@ 4, 4, 20, 56 BOX B_SINGLE + CHR (32)
@ 20, 41 SAY " Choix : Enter "
nTemp := ACHOICE (5, 6, 19, 55, aRepert)
@ 22, 4 SAY "Choix = " + IF (nTemp != 0, aPath[nTemp], "Aucun")
INKEY(0)
CLS
RETURN (NIL)


***
*
*  Avec la fonction en C 'C_DIR'
*
***
STATIC FUNCTION DIRTREE (cDir, cDirName, aRepert, aPath, cDep1, cDep2, bMsg)
LOCAL nBoucle, aSubDir := {}, nsize

IF (nSize := C_DIR (cDir + "*.*")) > 0
    C_DIR (cDir + "*.*", aSubdir := ARRAY(nSize))
ENDIF

AADD (aRepert, cDep1 + cDirName)
AADD (aPath, cDir)
EVAL (bmsg)

IF nsize > 0
     ASORT (aSubDir)
     FOR nBoucle := 1 TO nsize - 1
            DIRTREE (cDir + aSubDir[nBoucle] + "\", aSubDir[nBoucle],; 
                    aRepert, aPath, cDep2 + "", cDep2 + "  ", bmsg)
     NEXT
     DIRTREE (cDir + aSubDir[nBoucle] + "\", aSubDir[nBoucle],; 
              aRepert, aPath, cDep2 + "", cDep2 + "   ", bmsg)
ENDIF
RETURN (NIL)
