/* Extract from CLIPINTL.ZIP (12/12/92) */

/* appel de "extend.h" */
#include <extend.h>


struct find_t {
	char          reserved[21]; /* 21 bytes reserved to DOS internal use */
	unsigned char attrib;       /* DOS file attribute                    */
	unsigned      wr_time;      /* DOS file last write time              */
	unsigned      wr_date;      /* DOS file last write date              */
	unsigned long size;         /* File size in bytes                    */
	unsigned char name[13];     /* DOS file name with extension w/o path */
};


/* File attribute constants */

#define _A_NORMAL      0x00    /* Normal file - No read/write restrictions */
#define _A_RDONLY      0x01    /* Read only file                           */
#define _A_HIDDEN      0x02    /* Hidden file                              */
#define _A_SYSTEM      0x04    /* System file                              */
#define _A_VOLID       0x08    /* Volume ID file                           */
#define _A_SUBDIR      0x10    /* Subdirectory                             */
#define _A_ARCH        0x20    /* Archive file                             */


/* File search functions

	 _f_first()   relies on dos find first service
	 _f_next()    relies on dos find next service
	 
	 Find First                          Int 21h Function 4Eh
	 Find Next                           Int 21h Function 4Fh
	
	 Arguments are the same as the MSC library's _dos_findfirst() and
	 _dos_findnext() functions except for the order. See prototypes.
	
	WARNING: Return values are the opposite of MSC's library functions!
	
	 _f_first()    return          0       when FAILED (no matching files)
	 _f_next()     return          1       when SUCCESSFUL
*/

extern unsigned short _far _cdecl _f_first(
					const unsigned char _far *,  /* ASCIIZ pathname       */
					struct find_t _far *,        /* pointer on DTA buffer */
					unsigned );                  /* Search attribute word */

extern unsigned short _far _cdecl _f_next(struct find_t _far *);

